| The Gaudi Framework v29r1 (5cd95fa2)

- Main Page
- Related Pages
- Modules
- Namespaces
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Types | Public Member Functions | List of all members
Gaudi::Functional::details::insert_t Struct Reference

`#include <GaudiAlg/FunctionalDetails.h>`

## Public Types
template<typename Container >
using | c_remove_ptr_t = typename std::remove_pointer< typename Container::value_type >::type

## Public Member Functions
template<typename Container , typename Value >
auto | operator() (Container &c, Value &&v) const -> decltype(c.push_back(v))
template<typename Container , typename Value >
auto | operator() (Container &c, Value &&v) const -> decltype(c.insert(v))
template<typename Container , typename = typename std::enable_if<std::is_pointer<typename Container::value_type>::value>::type>
auto | operator() (Container &c, c_remove_ptr_t< Container > &&v) const
template<typename Container , typename Value >
void | operator() (Container &c, boost::optional< Value > &&v) const

## Detailed Description

Definition at line 139 of file FunctionalDetails.h.

## Member Typedef Documentation

template<typename Container >

using Gaudi::Functional::details::insert_t::c_remove_ptr_t = typename std::remove_pointer<typename Container::value_type>::type

Definition at line 142 of file FunctionalDetails.h.

## Member Function Documentation

template<typename Container , typename Value >

auto Gaudi::Functional::details::insert_t::operator() | ( | Container & | c,
|  | Value && | v
| ) |  | const -> decltype( c.push_back( v ) )
| inline

Definition at line 145 of file FunctionalDetails.h.

146 {
147 return c.push_back( std::forward<Value>( v ) );
148 }
gaudirun.c
c
Definition: gaudirun.py:407
template<typename Container , typename Value >

auto Gaudi::Functional::details::insert_t::operator() | ( | Container & | c,
|  | Value && | v
| ) |  | const -> decltype( c.insert( v ) )
| inline

Definition at line 151 of file FunctionalDetails.h.

152 {
153 return c.insert( std::forward<Value>( v ) );
154 }
gaudirun.c
c
Definition: gaudirun.py:407
template<typename Container , typename = typename std::enable_if<std::is_pointer<typename Container::value_type>::value>::type>

auto Gaudi::Functional::details::insert_t::operator() | ( | Container & | c,
|  | c_remove_ptr_t< Container > && | v
| ) |  | const
| inline

Definition at line 159 of file FunctionalDetails.h.

160 {
161 return operator()( c, new c_remove_ptr_t<Container>{std::move( v )} );
162 }
gaudirun.c
c
Definition: gaudirun.py:407
Gaudi::Functional::details::insert_t::operator()
auto operator()(Container &c, Value &&v) const -> decltype(c.push_back(v))
Definition: FunctionalDetails.h:145
std::move
T move(T...args)
template<typename Container , typename Value >

void Gaudi::Functional::details::insert_t::operator() | ( | Container & | c,
|  | boost::optional< Value > && | v
| ) |  | const
| inline

Definition at line 165 of file FunctionalDetails.h.

166 {
167 if ( v ) operator()( c, std::move( *v ) );
168 }
gaudirun.c
c
Definition: gaudirun.py:407
Gaudi::Functional::details::insert_t::operator()
auto operator()(Container &c, Value &&v) const -> decltype(c.push_back(v))
Definition: FunctionalDetails.h:145
std::move
T move(T...args)

The documentation for this struct was generated from the following file:

- GaudiAlg/GaudiAlg/FunctionalDetails.h